PauseGame:
	DI_RESET
	DI_ENABLE(kg_2)
	DI_GET
	cp	ky_clear
	ret	z
	jr	PauseGame

EndGame:
	call	ClearScreen
	call	IonFastCopy

	bcall(_HomeUp)
	INVERT_TEXT
	ld	hl,GameOver_Text
	bcall(_PutS)
	NORMAL_TEXT

	bcall(_PutS)
	ld	hl,(kills)
	bcall(_DispHL)

	ld	hl,$0003
	ld	(CurRow),hl
	ld	hl,(kills)
	ld	de,(highscore)
	bcall(_CpHLDE)
	jp	nc,GetHighScore

NoHighScore:
	ld	hl,HighScore_Text2
	bcall(_PutS)
	ld	de,$0004
	ld	(CurRow),de
	bcall(_PutS)
	ld	hl,(highscore)
	bcall(_DispHL)
	ei
	jr	PauseGame

AbortGame:
#ifndef	NOCAPTURE
	bcall(_GetKey)
#endif
	ei
	ret

GetHighScore:
	ld	hl,HighScore_Text1
	bcall(_PutS)
	bcall(_NewLine)

	ld	b,0
	ld	ix,input_buffer
EnterName_Loop:
	bcall(_GetCSC)

	cp	$30			;Alpha
	jr	nc,EnterName_Loop
	cp	$09			;Enter
	jr	z,EnterName_Done
	cp	$0F			;Clear
	jr	z,EnterName_Delete

	sub	$0A			;Plus
	jr	c,EnterName_Loop
	
	ld	l,a
	ld	a,b
	cp	9
	jr	z,EnterName_Loop

	ld	h,0
	ld	de,CharacterTable
	add	hl,de
	ld	a,(hl)
	ld	(ix),a
	bcall(_PutC)

#ifndef	NOCAPTURE
	push	bc
	bcall(_GetKey)
	pop	bc
#endif

	inc	ix
	inc	b
	jr	EnterName_Loop

EnterName_Delete:
	ld	a,b
	or	a
	jr	z,EnterName_Loop
	dec	ix
	ld	(ix),0
	ld	hl,CurCol
	dec	(hl)
	ld	a,$20			;Space
	bcall(_PutMap)
	dec	b
	jr	EnterName_Loop

EnterName_Done:
	ld	hl,input_buffer
	ld	de,HighScore_Name
	ld	bc,10
	ldir
	ld	hl,(kills)
	ld	(highscore),hl

	jr	AbortGame

.end