; Bounding-box collision detection technique
;
; HL  ->  [type][x][y][height]  <sprite 1>
; IX  ->  [type][x][delta_x][y][delta_y]  <sprite 2> 
;
; Carry set on failure, reset on success

BBox_Test:

BB_Check1:
	ld	a,(ix + xpos)
	add	a,meteor_width
	inc	a
	inc	hl			; HL -> [x]
	cp	(hl)
	ret	c

BB_Check2:
	ld	a,(hl)
	add	a,bullet_width
	inc	a
	cp	(ix + xpos)
	ret	c

BB_Check3:
	ld	a,(ix + ypos)
	add	a,meteor_height
	inc	a
	inc	hl			; HL -> [y]
	cp	(hl)
	ret	c

BB_Check4:
	ld	a,(hl)
	add	a,bullet_height
	inc	a
	cp	(ix + ypos)
	ret

.end