GetPlayerInput:
	DI_RESET
	DI_ENABLE(kg_1)

	DI_GET
	cp	ky_left
	jr	z,GPI_MoveLeft
	cp	ky_right
	jr	z,GPI_MoveRight

GPI_ChkShoot:
	DI_RESET	
	DI_ENABLE(kg_7)

	DI_GET
	cp	ky_2nd
	jr	z,GPI_Shoot
	cp	ky_mode
	call	z,PauseGame
	cp	ky_del
	jp	z,AbortGame

GPI_DrawPlayer:
	ld	ix,player_image
	ld	a,(player_x)
	ld	e,player_y
	call	PutSprite
	jp	GPI_EndRoutine

GPI_MoveLeft:
	ld	hl,player_x
	xor	a
	or	(hl)
	jr	z,GPI_ChkShoot
	dec	(hl)
	jp	GPI_ChkShoot

GPI_MoveRight:
	ld	hl,player_x
	ld	a,lcd_width - p_width
	cp	(hl)
	jr	z,GPI_ChkShoot
	inc	(hl)
	jp	GPI_ChkShoot

GPI_Shoot:
	ld	a,(bullet_delay)
	cp	b_delay_threshold
	jr	c,GPI_DrawPlayer

	ld	a,(active_bullets)
	cp	max_bullets
	jr	nc,GPI_DrawPlayer

	ld	hl,bullet_array - b_entry_size
	ld	de,b_entry_size
GPI_FindFreeEntry:
	add	hl,de
	ld	a,(hl)
	or	a
	jr	nz,GPI_FindFreeEntry

GPI_LoadNewBullet:
	inc	(hl)			;Valid bullet type

	inc	hl			;HL -> xpos
	ld	a,(player_x)
	add	a,3
	ld	(hl),a

	inc	hl			;HL -> ypos
	ld	(hl),b_start_y

	ld	hl,active_bullets
	inc	(hl)

	xor	a
	ld	(bullet_delay),a

	jp	GPI_DrawPlayer

GPI_EndRoutine:

.end
